pfSense - Bug #12747

Restarting the logging daemon during rotation also restarts 'sshguard', leading to frequent log

messages
02/01/2022 08:47 AM - Steve Wheeler

Status: Resolved Start date:

Priority: Normal Due date:

Assignee: Marcos M % Done: 100%

Category: Logging Estimated time: 0.00 hour

Target version: 2.8.0

Plus Target Version: 24.11 Affected Version: 2.6.0

Release Notes: Default Affected All
Architecture:

Description

sshguard has to restart when he logs are rotated in 2.6 in order to monitor the current file. When it does so it logs the service restart.
In an even moderately busy firewall this can produce a lot of log entries to the point it starts to hide other more important logs.
It appears to restart whenever any log is rotated, is that actually required?

For example on a test system where an IPSec tunnel is configured but never connects the ipsec log rotates frequently resulting in a

system log:

Jan 31 00:25:00 sshguard 29496 Exiting on signal.

Jan 31 00:25:00 sshguard 9940 Now monitoring attacks.
Jan 31 03:17:00 sshguard 9940 Exiting on signal.

Jan 31 03:17:00 sshguard 60321 Now monitoring attacks.
Jan 31 06:09:00 sshguard 60321 Exiting on signal.

Jan 31 06:09:00 sshguard 83661 Now monitoring attacks.
Jan 31 09:01:00 sshguard 83661 Exiting on signal.

Jan 31 09:01:00 sshguard 93166 Now monitoring attacks.
Jan 31 11:53:00 sshguard 93166 Exiting on signal.

Jan 31 11:53:00 sshguard 94019 Now monitoring attacks.

It's possible to mitigate this to some extent by increasing the log file size reducing the rotation frequency.

Associated revisions

Revision f32dca24 - 08/21/2024 08:18 PM - Marcos M
Stop sshguard spam in system logs. Fix #12747

Instead of restarting sshguard with each log rotation, keep it running
separately while monitoring the auth log file. This allows sshguard
start/stop events to still be included in the system log without
spamming it. When the log file is rotated by newsyslog, sshguard will
handle it and hence does not need to be signaled.

The use of deamon(8) allows the service to be restarted automatically

(every 60s) unless stopped via the service control mechanism used by
the GUL. It also prevents the start of multiple sshguard instances.

History

#1 - 02/21/2022 10:15 AM - Viktor Gurov
it seems to be related to #12833

#2 - 02/23/2022 06:20 PM - Todd Marimon

| am seeing this as well. In my case it seems to be every 2 minutes-- quite a lot of log noise! On pfSense 2.6.0.

Feb 24 00:13:00 sshguard 62471 Now monitoring attacks.
Feb 24 00:13:00 sshguard 28882 Exiting on signal.
Feb 24 00:11:00 sshguard 28882 Now monitoring attacks.
Feb 24 00:11:00 sshguard 90479 Exiting on signal.
#3 - 03/25/2022 11:45 PM - Car F

Having the same issue since 2.6.0.
#4 - 04/21/2022 01:40 AM - Michael TRVL ALBT

Having the same issue since 2.6.0 too.

#5 - 04/22/2022 06:38 AM - Marle Cua-chin
- File clipboard-202204221938-uajow.png added

I'm also experiencing the same issue on 2.6.0
#6 - 05/03/2022 03:08 AM - Antonio Pesce

I'm having the same issue on 2.6.0 on 6 pfSense instance.

#7 - 06/30/2022 05:21 AM - Franck Ck

- File clipboard-202206300621-7gjov.png added

same here on 22.05
Jun 30 06:09:00 sshguard Mow monitoring attacks.
Jun 30 06:09:00 sshguard Exiting on signal.
Jun 30 05:66:00 sshguard Mow monitoring attacks.
Jun 30 05:56:00 sshguard Exiting on signal.
Jun 30 05:46:00 sshguard Mow monitoring attacks.
Jun 30 05:46:00 sshguard Exiting on signal.
Jun 30 05:29:00 sshguard Mow monitoring attacks.
Jun 30 05:29:00 sshguard Exiting on signal.
Jun 30 05:07:00 sshguard Now maonitoring attacks.
Jun 30 05:07:00 sshguard Exiting on signal.
Jun 30 04:44:00 sshguard Mow monitoring attacks.
Jun 30 04:44:00 sshguard Exiting on signal.
Jun 30 04:27:00 sshguard Now monitoring attacks.
Jun 30 04:27:00 sshguard Exiting on signal.
Jun 30 04:10:00 sshguard Mow monitoring attacks.
Jun 30 04:10:00 sshguard Exiting on signal.

Jun 30 03:561:00 sshguard Mow monitoring attacks.

Jun 30 03:51:00 sshguard Exiting on signal.

Jun 30 03:34:00 sshguard Mow monitoring attacks.
Jun 30 03:34:00 sshguard Exiting on signal.

Jun 30 03:18:00 sshguard Mow monitoring attacks.

#8 - 07/05/2022 07:41 AM - Geovane Goncalves

I'm having the same issue on 2.6.0 at every 1 minute:

Jul 5 09:33:00 sshguard 77002 Exiting on signal.
Jul509:33:00 sshguard 19637 Now monitoring attacks.
Jul509:34:00 sshguard 19637 Exiting on signal.

Jul 509:34:00 sshguard 40779 Now monitoring attacks.
Jul509:35:00 sshguard 40779 Exiting on signal.
Jul509:35:00 sshguard 64718 Now monitoring attacks.
Jul 5 09:36:00 sshguard 64718 Exiting on signal.
Jul509:36:00 sshguard 6061 Now monitoring attacks.

Jul509:37:00 sshguard 6061 Exiting on signal.
Jul 509:37:00 sshguard 46190 Now monitoring attacks.

As a workaround | disabled the log packets matched from the default block rules in the ruleset to reduce the amount of system logs, but that didn't
happen before the upgrade. The frequency has dropped and now I'm watching.

After a period of calm, he logged back in every minute. Maybe on restart of syslogd. | changed the file size from 500K to 1024 and I'm tracking again.
Doubling the size of the logs from 512K to 1024K didn't work either. After about a day the logs became polluted again. No solution.

#9 - 08/22/2022 12:35 PM - Hayden Hill

| am having the same issue in 22.05.

#10 - 12/15/2022 02:21 AM - van trung tran
| am having the same issue in 22.05. Netgate XG1541

#11 - 01/22/2023 10:24 AM - Michael Kellogg
| am Still seeing this on 2.7 built on Fri Jan 20 03:01:02 UTC 2023

seems like every 5-10 minutes not a pattern i can figure out
#12 - 04/17/2023 02:55 PM - Mitch Claborn

Still an issue in 23.01. Suggestions:
1. Stop logging the stop and start. | can't see how this is useful.
2. Make sshguard smart enough to recognize a new log file without restarting. (e.g. send it a HUP to look for new log files)
3. Allow filtering on the log display to hide entries that we don't want to look at.

#13 - 04/17/2023 03:03 PM - Jim Pingle

Unfortunately a lot of this is out of our control as we are at the mercy of what sshguard supports. Not saying we won't keep looking for a solution, but
that our options here are limited.

The way it is currently used, sshguard will restart when syslogd restarts, which will happen any time a log is rotated. If your logs are rotating that fast,
you should figure out what is causing such a high volume of logs and take some sort of corrective actions:

e Reduce the logging of whatever is causing the high volume of logs
¢ Increase the log rotation size of the affected log (or all logs)
¢ Disable local logging and rely solely on remote logging

That high volume of logging would also be causing a high volume of disk writes on your device, which is likely undesirable as well.
#14 - 09/23/2023 12:07 PM - Jonathan Stafford

- File clipboard-202309230719-waesz.png added
- File clipboard-202309230720-yhwfb.png added

I'm having this problem as well, with 23.05.1-RELEASE. For me, the issue seems to be that the filter logs are rolling every 45 minutes to an hour:
Shell Output - Is -t /var/log/*.log.|0-9]

-rw------- 1 root wheel 514185 Sep 23 @87:15 /fvar/flog/filter.log.@
-rw------- 1 root wheel 522679 Sep 23 86:28 fvar/log/nginx.log.®
-rw------- 1 root wheel 516526 Sep 23 86:87 fvar/log/filter.log.1
-rw------- 1 root wheel 515792 Sep 23 85:13 /fvarflog/filter.log.2
-rw------- 1 root wheel 521367 Sep 23 ©4:26 /Swar/log/filter.log.3
-rw------- 1 root wheel 512888 Sep 23 03:44 fvar/log/filter.log.4
-rw------- 1 root wheel 514215 Sep 23 82:51 /fvarflog/filter.log.S
-rw------- 1 root wheel 514651 Sep 23 82:84 Svar/log/filter.log.6&
-rw------- 1 root wheel 511291 Sep 22 89:5@ fvar/log/dhcpd.log.@
-rw------- 1 root wheel 511281 Sep 28 23:36 fvar/log/nginx.log.1
-rw------- 1 root wheel 51126@ Sep 2@ 81:51 /var/log/dhcpd.log.1
-rw------- 1 root wheel 511129 Sep 18 81:54 fvar/log/nginx.log.2
-rw------- 1 2

root wheel 511883 Sep 17 15:37 /var/log/dhcpd.log.

v 1 - —— R i ru oA

The vast majority of the logs are coming from what | assume are system rules, the 1000000??? entries. These don't match the tracking ids of any
rules | have defined.

Shell Output - grep -v 'logfile turned over' /var/log/filter.log* | cut -d, -f4 | sort | uniq -c | sort -nr

15189 leeooeees3

6567 loooeaald3

248 lepooadead
29 168@383015

As far as | can tell these rules are matching:

* 1000000003 - Mostly IPvé mDNS on the LAN interface, although there is some DHCPv6 and ICMPv6.

¢ 1000000103 - Most of the logs are IPv4 on the WAN interface addressed to my WAN IP. A few of the logs are on the LAN interface, to an
assortment of IPs on 443.

e 1000000004 - DHCPvV6 from the WAN and ICMPv6 from the LAN

| do not have IPv6 enabled at System/Advanced/Networking/IPv6 Options->Allow IPv6. Additionally, it's a TP Link SG108E connected to the LAN
port, which doesn't support IPv6 anyway ... so not really clear where this is even coming from. | don't know enough about the log format to swear this
isn't 6in4. | have my own rules on the WAN and LAN to drop IPv6, but these never show any hits.

| have gotten an IPv6 address from my ISP in the past, but with no ability to use IPv6 on the network | turned that off.

| did just add some rules to drop 6in4 traffic in both directions and those haven't immediately shown any matches.

H—Gengah‘es—whefemd—yea—see—thati Ah it's at Status/System Logs/Settlngs/General Logglng Optlons >Log flrewall default bIocks At Ieast now I
don't know about this weird IPv6 traffic :)
#15 - 10/16/2023 02:52 PM - Geovane Gongcalves
Jonathan Stafford wrote in #note-14:

I'm having this problem as well, with 23.05.1-RELEASE. For me, the issue seems to be that the filter logs are rolling every 45 minutes to an
hour:

Shell Qutput - Is -It /var/log/*.log.[0-9]

Sie==o==s 1 root wheel 514185 Sep 23 87:15 /var/log/filter.log.@
Sie==o==s 1 root wheel 522679 Sep 23 086:28 /var/log/nginx.log.@®
-rW------- 1 root wheel 516526 Sep 23 06:87 fvar/log/filter.log.1
-rW------- 1 root wheel 515792 Sep 23 05:13 /fvar/log/filter.log.2
~[ie==o==s 1 root wheel 521367 Sep 23 ©84:26 /var/log/filter.log.3
-rW------- 1 root wheel 512888 Sep 23 83:44 Jvar/log/filter.log.4
-FW---=--=-- 1 root wheel 514215 Sep 23 82:51 fvar/log/filter.log.S
Sie==o==s 1 root wheel 514651 Sep 23 B82:84 /var/log/filter.log.6
-rW------- 1 root wheel 511291 Sep 22 @9:5@ /var/log/dhcpd.log.@
Sie==o==s 1 root wheel 511281 Sep 28 23:36 fvar/log/nginx.log.1
~[ie==o==s 1 root wheel 511266 Sep 20 ©81:51 /var/log/dhcpd.log.l
-rW------- 1 root wheel 511129 Sep 18 01:54 fvar/log/nginx.log.2
-FW---=--=-- 1 root wheel 511883 Sep 17 15:37 /fvar/log/dhcpd.log.2

- . [ 1 - —— = e mm T i rm oA

The vast majority of the logs are coming from what | assume are system rules, the 1000000??? entries. These don't match the tracking ids of
any rules | have defined.

Shell Output - grep -v 'logfile turned over' fvar/log/filter.log* | cut -d, -f4 | sort | uniq -¢ | sort -nr

15189 1lee0oaea3

6567 lepegoaled

246 1820000864
29 1680383015

As far as | can tell these rules are matching:

* 1000000003 - Mostly IPvé mDNS on the LAN interface, although there is some DHCPv6 and ICMPv6.

e 1000000103 - Most of the logs are IPv4 on the WAN interface addressed to my WAN IP. A few of the logs are on the LAN interface, to an
assortment of IPs on 443.

e 1000000004 - DHCPv6 from the WAN and ICMPv6 from the LAN

| do not have IPv6 enabled at System/Advanced/Networking/IPv6 Options->Allow IPv6. Additionally, it's a TP Link SG108E connected to the
LAN port, which doesn't support IPv6 anyway ... so not really clear where this is even coming from. | don't know enough about the log format to
swear this isn't 6in4. | have my own rules on the WAN and LAN to drop IPv6, but these never show any hits.

| have gotten an IPv6 address from my ISP in the past, but with no ability to use IPv6 on the network | turned that off.

| did just add some rules to drop 6in4 traffic in both directions and those haven't immediately shown any matches.

s at Status/System Logs/Settings/General Logging Options->Log firewall default blocks. At

: ; 2 Ahit'
least now | don't know about this weird IPv6 traffic :)

Maybe it helps:

| believe that we have reached a suitable configuration for our case.

I'll report the actions in case anyone finds this useful in the future:

PfSense 2.6.0 - FW/GW/Proxy wifi network approx 1300 daily users.
Logs are sent remotely for auditing purposes. Lots of filter logs!

Our final configuration to avoid "sshguard" spam looked like this:

We increased log file size to 100MB;

To avoid excessive disk consumption, retention has been changed to only two files in "log settings";
rw—— 1 root wheel 97239550 Jul 14 11:35 filter.log

rv—— 1 root wheel 102682474 Jul 13 16:16 filter.log.0

rw—— 1 root wheel 102697059 Jul 13 11:31 filter.log.1
To avoid the risk of unnecessary CPU consumption, log compression was disabled (UFS);

We disabled the log packets matched from the default block rules in the ruleset to reduce the amount of system logs;
We reviewed the other firewall rules and kept the logs strictly necessary;

Also to avoid space consumption, squid log retention has been reduced from 30 to 3 files.

Thanks,

Geovane
original post:
https://forum.netgate.com/topic/169923/tons-sshguard-log-entries-and-its-not-enabled/63?lang=pt-BR

#16 - 03/15/2024 05:08 PM - Daryl Morse

The original bug was reported against 2.6.0, but the problem has carried over to 2.7 x.
These messages are only one example of how the logs are being literally polluted by useless garbage messages. This is not cosmetic. Garbage
messages cause important messages to be lost. The fix is not to reduce the size of the logs. The fix is to eliminate the garbage either by preventing

them from being generated in the first place or if that isn't possible, by filtering them after they are created so there is room in the log for important
messages.

#17 - 08/05/2024 05:08 PM - — luckman212
Damn. | got bit by this today when trying to troubleshoot a remote firewall. Filled to the brim with the logspew (pfSense+ 24.03)

#18 - 08/17/2024 05:24 PM - Marcos M
- Subject changed from System log is filled by sshquard to sshguard spams the system log
- Status changed from New to Ready To Test

Here's a patch for 24.03 for testing:
Apply then reboot.
#19 - 08/17/2024 06:43 PM - Christopher Cope
Marcos M wrote in #note-18:
Here's a patch for 24.03 for testing: {{collapse

[--]
1

Apply then reboot.

Tested on 24.03 and it seems to be working as intended. Even when syslogd is restarted, sshguard doesn't fill the logs. sshguard logs are also nicely
placed into /var/log/sshguard.log. The logs are much more readable.

#20 - 08/21/2024 08:24 PM - Marcos M

- Status changed from Ready To Test to Feedback

- Assignee set to Marcos M

- Target version changed from CE-Next to 2.8.0

- Plus Target Version changed from Plus-Next to 24.08

With £32dca244955da9007e1bc75801d486b5f70352e sshguard now monitors auth.log directly instead of relying on syslogd to send it messages.
Edit: I've pushed an additional change to remove an unnecessary service restart: commit:a82bb079330fb681b9d7c6eb1e52ae2484184c04

#21 - 08/21/2024 08:24 PM - Marcos M
- % Done changed from 0 to 100

#22 - 08/22/2024 03:01 PM - Danilo Zrenjanin
- Status changed from Feedback to Resolved

| was able to reproduce the issue on 24.03.
After applying the patch, | got the same results.

Aug 22 15:11:00 sshguard 15993 Now monitoring attacks.
Aug 22 15:11:00 sshguard 55230 Exiting on signal.
Aug 22 15:08:00
Aug 22 15:08:00
Aug 22 15:05:00
Aug 22 15:05:00
Aug 22 15:02:00
Aug 22 15:02:00
Aug 22 14:59:05
_logs)

Aug 22 14:59:05
Aug 22 14:59:05

base) : Fetched patch ssh_logs

Aug 22 14:59:02
Aug 22 14:59:02

al Database): System: Patches: edited a patch.

Aug 22 14:58:25

Aug 22 14:58:25

Aug 22 14:58:25
package.

Aug 22 14:58:25

Aug 22 14:58:25

dded an early shellcmd: apply patches

Aug 22 14:58:25
Aug 22 14:58:25

e during package install for System Patches.

Aug 22 14:58:25
Aug 22 14:58:21
Aug 22 14:58:21
atabase) : Creating
Aug 22 14:58:00
Aug 22 14:58:00
Aug 22 14:57:10

' returned exit code '14', the output was ''

Aug 22 14:52:00
Aug 22 14:52:00
Aug 22 14:46:00
Aug 22 14:46:00
Aug 22 14:40:00
Aug 22 14:40:00
Aug 22 14:34:00
Aug 22 14:34:00
Aug 22 14:28:00
Aug 22 14:28:00
Aug 22 14:22:00
Aug 22 14:22:00
Aug 22 14:16:00
Aug 22 14:16:00
Aug 22 14:10:00
Aug 22 14:10:00
Aug 22 14:04:00
Aug 22 14:04:00
Aug 22 13:58:00
Aug 22 13:58:00
Aug 22 13:52:00
Aug 22 13:52:00
Aug 22 13:46:00
Aug 22 13:46:00
Aug 22 13:40:00
Aug 22 13:40:00
Aug 22 13:34:00
Aug 22 13:34:00
Aug 22 13:28:00
Aug 22 13:28:00
Aug 22 13:22:00
Aug 22 13:22:00
Aug 22 13:16:00
Aug 22 13:16:00
Aug 22 13:10:00
Aug 22 13:10:00
Aug 22 13:04:00
Aug 22 13:04:00
Aug 22 12:58:00
Aug 22 12:58:00

sshguard 55230 Now monitoring attacks.

sshguard 97999 Exiting on signal.

sshguard 97999 Now monitoring attacks.

sshguard 33690 Exiting on signal.

sshguard 33690 Now monitoring attacks.

sshguard 30903 Exiting on signal.

php-fpm 536 System Patches: Patch fetched successfully (ID: 66c752367£64b, DESCR: ssh
check_reload_status 589 Syncing firewall

php-fpm 536 /system_patches.php: Configuration Change: admin@192.168.33.1 (Local Data
check_reload_status 589 Syncing firewall

php-fpm 92470 /system_patches_edit.php: Configuration Change: admin@192.168.33.1 (Loc
pkg-static 54621 pfSense-pkg-System_Patches-2.2.11_15 installed

php 65227 //etc/rc.packages: Successfully installed package: System Patches.

php 65227 //etc/rc.packages: Configuration Change: (system): Installed System Patches
check_reload_status 589 Syncing firewall

php 65227 //etc/rc.packages: Configuration Change: (system): System Patches package a
check_reload_status 589 Syncing firewall

php 65227 //etc/rc.packages: Configuration Change: (system): Intermediate config writ
php 65227 //etc/rc.packages: Beginning package installation for System Patches
check_reload_status 589 Syncing firewall

php-fpm 69927 /pkg_mgr_install.php: Configuration Change: admin@192.168.33.1 (Local D
restore point before package installation.

sshguard 30903 Now monitoring attacks.

sshguard 87083 Exiting on signal.

php-fpm 69927 /pkg_mgr_installed.php: The command '/usr/local/sbin/pfSense-repo-setup
sshguard 87083 Now monitoring attacks.

sshguard 54118 Exiting on signal.

sshguard 54118 Now monitoring attacks.

sshguard 32464 Exiting on signal.

sshguard 32464 Now monitoring attacks.

sshguard 17167 Exiting on signal.

sshguard 17167 Now monitoring attacks.

sshguard 95472 Exiting on signal.

sshguard 95472 Now monitoring attacks.

sshguard 62604 Exiting on signal.

sshguard 62604 Now monitoring attacks.

sshguard 41788 Exiting on signal.

sshguard 41788 Now monitoring attacks.

sshguard 11625 Exiting on signal.

sshguard 11625 Now monitoring attacks.

sshguard 83934 Exiting on signal.

sshguard 83934 Now monitoring attacks.

sshguard 52778 Exiting on signal.

sshguard 52778 Now monitoring attacks.

sshguard 45828 Exiting on signal.

sshguard 45828 Now monitoring attacks.

sshguard 9833 Exiting on signal.

sshguard 9833 Now monitoring attacks.

sshguard 82710 Exiting on signal.

sshguard 82710 Now monitoring attacks.

sshguard 56637 Exiting on signal.

sshguard 56637 Now monitoring attacks.

sshguard 29766 Exiting on signal.

sshguard 29766 Now monitoring attacks.

sshguard 96576 Exiting on signal.

sshguard 96576 Now monitoring attacks.

sshguard 72471 Exiting on signal.

sshguard 72471 Now monitoring attacks.

sshguard 40315 Exiting on signal.

sshguard 40315 Now monitoring attacks.

sshguard 33853 Exiting on signal.

sshguard 33853 Now monitoring attacks.

sshguard 3459 Exiting on signal.

sshguard 3459 Now monitoring attacks.

sshguard 78835 Exiting on signal.

#23 - 08/22/2024 03:16 PM - Danilo Zrenjanin
- Status changed from Resolved to Feedback

#24 - 08/23/2024 03:54 AM - Marcos M

Make sure to reboot after applying the patches.

#25 - 08/24/2024 06:07 AM - Danilo Zrenjanin

- Status changed from Feedback to Resolved

Upon testing against the latest development build, | could not replicate the reported issue. Therefore, | am marking this ticket as resolved.

#26 - 10/04/2024 05:51 PM - Jim Pingle

- Subject changed from sshguard spams the system log to Restarting the logging daemon during rotation also restarts “'sshguard™", leading to

frequent log messages

#27 - 10/11/2024 02:31 PM - Jim Pingle
- Plus Target Version changed from 24.08 to 24.11
